/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.enums.EnumLabeltype;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TCoreStage.TCoreStagePath;
import de.ship.db.tables.TCoreTranslationKey.TCoreTranslationKeyPath;
import de.ship.db.tables.TInputStyle.TInputStylePath;
import de.ship.db.tables.records.TInputLabelRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Check;
import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.Internal;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TInputLabel extends TableImpl<TInputLabelRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_input_label</code>
     */
    public static final TInputLabel T_INPUT_LABEL = new TInputLabel();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TInputLabelRecord> getRecordType() {
        return TInputLabelRecord.class;
    }

    /**
     * The column <code>common_dd.t_input_label.pk_input_label</code>.
     */
    public final TableField<TInputLabelRecord, Integer> PK_INPUT_LABEL = createField(DSL.name("pk_input_label"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_input_label.fk_style</code>.
     */
    public final TableField<TInputLabelRecord, Integer> FK_STYLE = createField(DSL.name("fk_style"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_input_label.fk_element</code>. reference to
     * form or variable group
     */
    public final TableField<TInputLabelRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER.nullable(false), this, "reference to form or variable group");

    /**
     * The column <code>common_dd.t_input_label.label_posx</code>. x position of
     * label
     */
    public final TableField<TInputLabelRecord, Integer> LABEL_POSX = createField(DSL.name("label_posx"), SQLDataType.INTEGER.nullable(false), this, "x position of label");

    /**
     * The column <code>common_dd.t_input_label.label_posy</code>. y position of
     * label
     */
    public final TableField<TInputLabelRecord, Integer> LABEL_POSY = createField(DSL.name("label_posy"), SQLDataType.INTEGER.nullable(false), this, "y position of label");

    /**
     * The column <code>common_dd.t_input_label.fk_lang_key</code>. language key
     * of label
     */
    public final TableField<TInputLabelRecord, String> FK_LANG_KEY = createField(DSL.name("fk_lang_key"), SQLDataType.CLOB, this, "language key of label");

    /**
     * The column <code>common_dd.t_input_label.lastchange</code>.
     */
    public final TableField<TInputLabelRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_input_label.stage</code>. stage of element;
     * see T_CORE_STAGE for details
     */
    public final TableField<TInputLabelRecord, Integer> STAGE = createField(DSL.name("stage"), SQLDataType.INTEGER.nullable(false).defaultValue(DSL.field(DSL.raw("1"), SQLDataType.INTEGER)), this, "stage of element; see T_CORE_STAGE for details");

    /**
     * The column <code>common_dd.t_input_label.label_type</code>.
     */
    public final TableField<TInputLabelRecord, EnumLabeltype> LABEL_TYPE = createField(DSL.name("label_type"), SQLDataType.VARCHAR.defaultValue(DSL.field(DSL.raw("'standard'::common_dd.enum_labeltype"), SQLDataType.VARCHAR)).asEnumDataType(EnumLabeltype.class), this, "");

    /**
     * The column <code>common_dd.t_input_label.data</code>.
     */
    public final TableField<TInputLabelRecord, JSONB> DATA = createField(DSL.name("data"), SQLDataType.JSONB, this, "");

    private TInputLabel(Name alias, Table<TInputLabelRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TInputLabel(Name alias, Table<TInputLabelRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_input_label</code> table reference
     */
    public TInputLabel(String alias) {
        this(DSL.name(alias), T_INPUT_LABEL);
    }

    /**
     * Create an aliased <code>common_dd.t_input_label</code> table reference
     */
    public TInputLabel(Name alias) {
        this(alias, T_INPUT_LABEL);
    }

    /**
     * Create a <code>common_dd.t_input_label</code> table reference
     */
    public TInputLabel() {
        this(DSL.name("t_input_label"), null);
    }

    public <O extends Record> TInputLabel(Table<O> path, ForeignKey<O, TInputLabelRecord> childPath, InverseForeignKey<O, TInputLabelRecord> parentPath) {
        super(path, childPath, parentPath, T_INPUT_LABEL);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TInputLabelPath extends TInputLabel implements Path<TInputLabelRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TInputLabelPath(Table<O> path, ForeignKey<O, TInputLabelRecord> childPath, InverseForeignKey<O, TInputLabelRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TInputLabelPath(Name alias, Table<TInputLabelRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TInputLabelPath as(String alias) {
            return new TInputLabelPath(DSL.name(alias), this);
        }

        @Override
        public TInputLabelPath as(Name alias) {
            return new TInputLabelPath(alias, this);
        }

        @Override
        public TInputLabelPath as(Table<?> alias) {
            return new TInputLabelPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TInputLabelRecord, Integer> getIdentity() {
        return (Identity<TInputLabelRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TInputLabelRecord> getPrimaryKey() {
        return Keys.PK_INPUT_LABEL;
    }

    @Override
    public List<ForeignKey<TInputLabelRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_INPUT_LABEL__FK_INPUT_LABEL_STYLE, Keys.T_INPUT_LABEL__FK_INPUT_LABEL_ELEMENT, Keys.T_INPUT_LABEL__FK_INPUT_LABEL_LANGKEY, Keys.T_INPUT_LABEL__FK_INPUT_LABEL_STAGE);
    }

    private transient TInputStylePath _tInputStyle;

    /**
     * Get the implicit join path to the <code>common_dd.t_input_style</code>
     * table.
     */
    public TInputStylePath tInputStyle() {
        if (_tInputStyle == null)
            _tInputStyle = new TInputStylePath(this, Keys.T_INPUT_LABEL__FK_INPUT_LABEL_STYLE, null);

        return _tInputStyle;
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_INPUT_LABEL__FK_INPUT_LABEL_ELEMENT, null);

        return _tCoreElementHierarchy;
    }

    private transient TCoreTranslationKeyPath _tCoreTranslationKey;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_translation_key</code> table.
     */
    public TCoreTranslationKeyPath tCoreTranslationKey() {
        if (_tCoreTranslationKey == null)
            _tCoreTranslationKey = new TCoreTranslationKeyPath(this, Keys.T_INPUT_LABEL__FK_INPUT_LABEL_LANGKEY, null);

        return _tCoreTranslationKey;
    }

    private transient TCoreStagePath _tCoreStage;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_stage</code>
     * table.
     */
    public TCoreStagePath tCoreStage() {
        if (_tCoreStage == null)
            _tCoreStage = new TCoreStagePath(this, Keys.T_INPUT_LABEL__FK_INPUT_LABEL_STAGE, null);

        return _tCoreStage;
    }

    @Override
    public List<Check<TInputLabelRecord>> getChecks() {
        return Arrays.asList(
            Internal.createCheck(this, DSL.name("nullable_input_label"), "(((fk_lang_key IS NOT NULL) OR (data IS NOT NULL)))", true)
        );
    }

    @Override
    public TInputLabel as(String alias) {
        return new TInputLabel(DSL.name(alias), this);
    }

    @Override
    public TInputLabel as(Name alias) {
        return new TInputLabel(alias, this);
    }

    @Override
    public TInputLabel as(Table<?> alias) {
        return new TInputLabel(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputLabel rename(String name) {
        return new TInputLabel(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputLabel rename(Name name) {
        return new TInputLabel(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TInputLabel rename(Table<?> name) {
        return new TInputLabel(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLabel where(Condition condition) {
        return new TInputLabel(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLabel where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLabel where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLabel where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputLabel where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputLabel where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputLabel where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TInputLabel where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLabel whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TInputLabel whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
